////////////////////////////////////////////////////////////////////////////////
//
// (C) 2010 Sarah Eris Horsley Caffee
//
// mandelbrot - A simple Mandelbrot Set viewer.
//
// Julia.h
// Julia set calculator class definition
//
////////////////////////////////////////////////////////////////////////////////

#ifndef JULIA_H
#define JULIA_H

#include <iostream>
#include <string>
#include <typeinfo>

#include "SDL.h"

#include "Fractal.h"

class Julia : public Fractal
   {
   public:
   Julia();

   bool calc_set();
   bool init(SDL_Surface * surf);

   bool get_option(std::string option, void * value) const;
   bool set_option(std::string option, void * value);

   std::string const & get_fractal_name() const;

   private:

   void draw_pixel(int x, int y, Uint32 * color);
   void set_display_name();

   double k_re;
   double k_im;

   };

namespace
   {
   class JuliaCreator : public FractalCreator
      {
      public:
      JuliaCreator()
	 {
	 std::cerr << "Julia is called >" << typeid(Julia).name() << "<" << std::endl;
	 get_Fractal_map()[typeid(Julia).name()]=this;
	 }

      virtual Fractal * create() const
	 {
	 return new Julia;
	 }
      } the_Julia_creator;
   }
#endif
